#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';
        require "flush.pl";

        &ReadInput(*INPUT);
	&ParseData(*GLOBAL, $INPUT);

	$hostname = &IpswitchName();

        # Print out header
        print "HTTP/1.0 200 Script results follow\n";
#        &PrintButtonBar("NPHEADER", "Trace Route from: $hostname");
        &DispHelp;

        local ($ip_addr);
	$ip_addr = &GetValue($GLOBAL[0]);

        if( &IsIPAddr($ip_addr) ne 1 ) {
	     print "<center>Invalid IP address: \"$ip_addr\"</center>";
        }
	else {
		# Print out form
		&traceroute($ip_addr);
	}

        # Print out trailer
	#print "<hr size=4>";
#        &PrintButtonBar("TRAILER");
        &PrintToe;
####### END MAIN ########

sub PrintToe {
    &SetUpHelp;
    &PrintHeadToe2("TRAILER",
                  "", 
                  "",
                  "/voy.guide/Monitor_tasks.fm.html",
                  "/cgi-bin/NPH-traceroute.pl?IH=$nhelp",
                  "");
}

sub DispHelp {
    &SetUpHelp;
    &PrintHeadToe2("HEADER",
                  "Trace Route from: $hostname", 
                  "",
                  "/voy.guide/Monitor_tasks.fm.html",
                  "/cgi-bin/NPH-traceroute.pl?IH=$nhelp",
                  "");
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagRouteFields.html");
        while (<FD>) {
	    print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub traceroute {
    local ($ip_address, $tr_time) = @_;
    local ($hostname);

#    $SIG{"ALRM"} = "TRCAlrmHandler"; alarm (15);
#    $pidTRC = open (FD, "/usr/sbin/traceroute $ip_address 2>&1 |");

    open (FD, "/usr/sbin/traceroute $ip_address 2>&1 |");

    print "<pre>\n";
    while (<FD>) {
	print "$_";
	&flush(STDOUT);
    }

#    print "\n\n    Trace route from \"$hostname\" to \"$ip_address\" ";
#    print "for 15 seconds max.\n";

    print "</pre>\n";
    close(FD);
}

sub TRCAlrmHandler {
        $SIG{"ALRM"} = "DEFAULT";
	kill (1, $pidTRC+1);
	return;
}

