if (!defined &__NCURSES_H) {
    eval 'sub __NCURSES_H {1;}';
    eval 'sub CURSES {1;}';
    eval 'sub CURSES_H {1;}';
    require 'stdio.ph';
    require 'stdarg.ph';
    if (!defined &NOTERMIOS) {
	require 'termios.ph';
	if (!defined &TERMIOS) {
	    eval 'sub TERMIOS {1;}';
	}
    }
    else {
	require 'sgtty.ph';
	require 'sys/ioctl.ph';
    }
    require 'unctrl.ph';
    eval 'sub bool {char;}';
    eval 'sub A_ATTRIBUTES {0xffffff00;}';
    eval 'sub A_NORMAL {0x00000000;}';
    eval 'sub A_STANDOUT {0x00010000;}';
    eval 'sub A_UNDERLINE {0x00020000;}';
    eval 'sub A_REVERSE {0x00040000;}';
    eval 'sub A_BLINK {0x00080000;}';
    eval 'sub A_DIM {0x00100000;}';
    eval 'sub A_BOLD {0x00200000;}';
    eval 'sub A_ALTCHARSET {0x00400000;}';
    eval 'sub A_INVIS {0x00800000;}';
    eval 'sub A_PROTECT {0x01000000;}';
    eval 'sub A_CHARTEXT {0x000000ff;}';
    eval 'sub A_COLOR {0x0000ff00;}';
    eval 'sub COLOR_PAIR {
        local($n) = @_;
        eval "($n << 8)";
    }';
    eval 'sub PAIR_NUMBER {
        local($a) = @_;
        eval "(($a & defined &A_COLOR && &A_COLOR) >> 8)";
    }';
    eval 'sub COLOR_BLACK {0;}';
    eval 'sub COLOR_RED {1;}';
    eval 'sub COLOR_GREEN {2;}';
    eval 'sub COLOR_YELLOW {3;}';
    eval 'sub COLOR_BLUE {4;}';
    eval 'sub COLOR_MAGENTA {5;}';
    eval 'sub COLOR_CYAN {6;}';
    eval 'sub COLOR_WHITE {7;}';
    eval 'sub ACS_ULCORNER {(defined &acs_map && &acs_map[ord(\'l\')]);}';
    eval 'sub ACS_LLCORNER {(defined &acs_map && &acs_map[ord(\'m\')]);}';
    eval 'sub ACS_URCORNER {(defined &acs_map && &acs_map[ord(\'k\')]);}';
    eval 'sub ACS_LRCORNER {(defined &acs_map && &acs_map[ord(\'j\')]);}';
    eval 'sub ACS_RTEE {(defined &acs_map && &acs_map[ord(\'u\')]);}';
    eval 'sub ACS_LTEE {(defined &acs_map && &acs_map[ord(\'t\')]);}';
    eval 'sub ACS_BTEE {(defined &acs_map && &acs_map[ord(\'v\')]);}';
    eval 'sub ACS_TTEE {(defined &acs_map && &acs_map[ord(\'w\')]);}';
    eval 'sub ACS_HLINE {(defined &acs_map && &acs_map[ord(\'q\')]);}';
    eval 'sub ACS_VLINE {(defined &acs_map && &acs_map[ord(\'x\')]);}';
    eval 'sub ACS_PLUS {(defined &acs_map && &acs_map[ord(\'n\')]);}';
    eval 'sub ACS_S1 {(defined &acs_map && &acs_map[ord(\'o\')]);}';
    eval 'sub ACS_S9 {(defined &acs_map && &acs_map[ord(\'s\')]);}';
    eval 'sub ACS_DIAMOND {(defined &acs_map && &acs_map[ord(\'`\')]);}';
    eval 'sub ACS_CKBOARD {(defined &acs_map && &acs_map[ord(\'a\')]);}';
    eval 'sub ACS_DEGREE {(defined &acs_map && &acs_map[ord(\'f\')]);}';
    eval 'sub ACS_PLMINUS {(defined &acs_map && &acs_map[ord(\'g\')]);}';
    eval 'sub ACS_BULLET {(defined &acs_map && &acs_map[ord(\'~\')]);}';
    eval 'sub ACS_LARROW {(defined &acs_map && &acs_map[ord(\',\')]);}';
    eval 'sub ACS_RARROW {(defined &acs_map && &acs_map[ord(\'+\')]);}';
    eval 'sub ACS_DARROW {(defined &acs_map && &acs_map[ord(\'.\')]);}';
    eval 'sub ACS_UARROW {(defined &acs_map && &acs_map[ord(\'-\')]);}';
    eval 'sub ACS_BOARD {(defined &acs_map && &acs_map[ord(\'h\')]);}';
    eval 'sub ACS_LANTERN {(defined &acs_map && &acs_map[ord(\'I\')]);}';
    eval 'sub ACS_BLOCK {(defined &acs_map && &acs_map[ord(\'0\')]);}';
    if (!defined &TRUE) {
	eval 'sub TRUE {(1);}';
	eval 'sub FALSE {(0);}';
    }
    eval 'sub ERR {(-1);}';
    eval 'sub OK {(0);}';
    eval 'sub _SUBWIN {0x01;}';
    eval 'sub _ENDLINE {0x02;}';
    eval 'sub _FULLWIN {0x04;}';
    eval 'sub _SCROLLWIN {0x08;}';
    eval 'sub _ISPAD {0x10;}';
    eval 'sub _HASMOVED {0x20;}';
    eval 'sub _NOCHANGE {-1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub TRACE_DISABLE {0x00;}';
    eval 'sub TRACE_ORDINARY {0x01;}';
    eval 'sub TRACE_CHARPUT {0x02;}';
    eval 'sub TRACE_MAXIMUM {0x0f;}';
    if (defined &__cplusplus) {
    }
    eval 'sub wgetstr {
        local($w, $s) = @_;
        eval " &wgetnstr($w, $s, -1)";
    }';
    eval 'sub napms {
        local($x) = @_;
        eval " &usleep(1000*$x)";
    }';
    eval 'sub setterm {
        local($term) = @_;
        eval " &setupterm($term, 1, 0)";
    }';
    eval 'sub fixterm {
        eval " &reset_prog_mode()";
    }';
    eval 'sub resetterm {
        eval " &reset_shell_mode()";
    }';
    eval 'sub saveterm {
        eval " &def_prog_mode()";
    }';
    eval 'sub crmode {
        eval " &cbreak()";
    }';
    eval 'sub nocrmode {
        eval " &nocbreak()";
    }';
    eval 'sub gettmode {
        eval "";
    }';
    eval 'sub getyx {
        local($win,$y,$x) = @_;
        eval "($y = ($win)->defined &_cury && &_cury, $x = ($win)->defined &_curx && &_curx)";
    }';
    eval 'sub getbegyx {
        local($win,$y,$x) = @_;
        eval "($y = ($win)->defined &_begy && &_begy, $x = ($win)->defined &_begx && &_begx)";
    }';
    eval 'sub getmaxyx {
        local($win,$y,$x) = @_;
        eval "($y = ($win)->defined &_maxy && &_maxy + 1, $x = ($win)->defined &_maxx && &_maxx + 1)";
    }';
    eval 'sub getsyx {
        local($y,$x) = @_;
        eval " &getyx(defined &stdscr && &stdscr, $y, $x)";
    }';
    eval 'sub setsyx {
        local($y,$x) = @_;
        eval "(defined &stdscr && &stdscr->defined &_cury && &_cury = $y, defined &stdscr && &stdscr->defined &_curx && &_curx = $x)";
    }';
    eval 'sub wbkgdset {
        local($win,$ch) = @_;
        eval "(($win)->defined &_bkgd && &_bkgd = $ch)";
    }';
    eval 'sub getattrs {
        local($win) = @_;
        eval "($win->defined &_attrs && &_attrs)";
    }';
    eval 'sub getmaxx {
        local($win) = @_;
        eval "(($win)->defined &_maxx && &_maxx + 1)";
    }';
    eval 'sub getmaxy {
        local($win) = @_;
        eval "(($win)->defined &_maxy && &_maxy + 1)";
    }';
    eval 'sub winch {
        local($win) = @_;
        eval "(($win)->defined &_line && &_line[($win)->defined &_cury && &_cury][($win)->defined &_curx && &_curx])";
    }';
    eval 'sub wstandout {
        local($win) = @_;
        eval "( &wattrset($win,defined &A_STANDOUT && &A_STANDOUT))";
    }';
    eval 'sub wstandend {
        local($win) = @_;
        eval "( &wattrset($win,defined &A_NORMAL && &A_NORMAL))";
    }';
    eval 'sub wattrset {
        local($win,$at) = @_;
        eval "(($win)->defined &_attrs && &_attrs = ($at))";
    }';
    eval 'sub subpad {
        local($p,$l,$c,$y,$x) = @_;
        eval " &derwin($p,$l,$c,$y,$x)";
    }';
    eval 'sub scroll {
        local($win) = @_;
        eval " &wscrl($win,1)";
    }';
    eval 'sub touchwin {
        local($win) = @_;
        eval " &wtouchln(($win), 0, ($win)->defined &_maxy && &_maxy + 1, 1)";
    }';
    eval 'sub touchline {
        local($win, $s, $c) = @_;
        eval " &wtouchln(($win), $s, $c, 1)";
    }';
    eval 'sub untouchwin {
        local($win) = @_;
        eval " &wtouchln(($win), 0, ($win)->defined &_maxy && &_maxy + 1, 0)";
    }';
    eval 'sub box {
        local($win, $v, $h) = @_;
        eval " &wborder($win, $v, $v, $h, $h, 0, 0, 0, 0)";
    }';
    eval 'sub border {
        local($ls, $rs, $ts, $bs, $tl, $tr, $bl, $br) = @_;
        eval " &wborder(defined &stdscr && &stdscr, $ls, $rs, $ts, $bs, $tl, $tr, $bl, $br)";
    }';
    eval 'sub hline {
        local($ch, $n) = @_;
        eval " &whline(defined &stdscr && &stdscr, $ch, $n)";
    }';
    eval 'sub vline {
        local($ch, $n) = @_;
        eval " &wvline(defined &stdscr && &stdscr, $ch, $n)";
    }';
    eval 'sub winsstr {
        local($w, $s) = @_;
        eval " &winsnstr($w, $s, 0)";
    }';
    eval 'sub redrawwin {
        local($w) = @_;
        eval " &wredrawln($w, 0, $w->defined &_maxy && &_maxy+1)";
    }';
    eval 'sub waddstr {
        local($win,$str) = @_;
        eval " &waddnstr($win,$str,-1)";
    }';
    eval 'sub waddchstr {
        local($win,$str) = @_;
        eval " &waddchnstr($win,$str,-1)";
    }';
    eval 'sub bkgdset {
        local($ch) = @_;
        eval " &wbkgdset(defined &stdscr && &stdscr,$ch)";
    }';
    eval 'sub bkgd {
        local($ch) = @_;
        eval " &wbkgd(defined &stdscr && &stdscr,$ch)";
    }';
    eval 'sub inch {
        eval " &winch(defined &stdscr && &stdscr)";
    }';
    eval 'sub standout {
        eval " &wstandout(defined &stdscr && &stdscr)";
    }';
    eval 'sub standend {
        eval " &wstandend(defined &stdscr && &stdscr)";
    }';
    eval 'sub attron {
        local($at) = @_;
        eval " &wattron(defined &stdscr && &stdscr,$at)";
    }';
    eval 'sub attroff {
        local($at) = @_;
        eval " &wattroff(defined &stdscr && &stdscr,$at)";
    }';
    eval 'sub attrset {
        local($at) = @_;
        eval " &wattrset(defined &stdscr && &stdscr,$at)";
    }';
    eval 'sub addch {
        local($ch) = @_;
        eval " &waddch(defined &stdscr && &stdscr,$ch)";
    }';
    eval 'sub echochar {
        local($c) = @_;
        eval " &wechochar(defined &stdscr && &stdscr, $c)";
    }';
    eval 'sub getch {
        eval " &wgetch(defined &stdscr && &stdscr)";
    }';
    eval 'sub addstr {
        local($str) = @_;
        eval " &waddnstr(defined &stdscr && &stdscr,$str,-1)";
    }';
    eval 'sub getstr {
        local($str) = @_;
        eval " &wgetstr(defined &stdscr && &stdscr,$str)";
    }';
    eval 'sub move {
        local($y, $x) = @_;
        eval " &wmove(defined &stdscr && &stdscr,$y,$x)";
    }';
    eval 'sub clear {
        eval " &wclear(defined &stdscr && &stdscr)";
    }';
    eval 'sub erase {
        eval " &werase(defined &stdscr && &stdscr)";
    }';
    eval 'sub clrtobot {
        eval " &wclrtobot(defined &stdscr && &stdscr)";
    }';
    eval 'sub clrtoeol {
        eval " &wclrtoeol(defined &stdscr && &stdscr)";
    }';
    eval 'sub insertln {
        eval " &winsdelln(defined &stdscr && &stdscr, 1)";
    }';
    eval 'sub winsertln {
        local($w) = @_;
        eval " &winsdelln($w, 1)";
    }';
    eval 'sub deleteln {
        eval " &winsdelln(defined &stdscr && &stdscr, -1)";
    }';
    eval 'sub wdeleteln {
        local($w) = @_;
        eval " &winsdelln($w, -1)";
    }';
    eval 'sub refresh {
        eval " &wrefresh(defined &stdscr && &stdscr)";
    }';
    eval 'sub insch {
        local($c) = @_;
        eval " &winsch(defined &stdscr && &stdscr,$c)";
    }';
    eval 'sub delch {
        eval " &wdelch(defined &stdscr && &stdscr)";
    }';
    eval 'sub setscrreg {
        local($t,$b) = @_;
        eval " &wsetscrreg(defined &stdscr && &stdscr,$t,$b)";
    }';
    eval 'sub scrl {
        local($n) = @_;
        eval " &wscrl(defined &stdscr && &stdscr,$n)";
    }';
    eval 'sub timeout {
        local($delay) = @_;
        eval " &wtimeout(defined &stdscr && &stdscr, $delay)";
    }';
    eval 'sub addnstr {
        local($str,$n) = @_;
        eval " &waddnstr(defined &stdscr && &stdscr,$str,$n)";
    }';
    eval 'sub addchstr {
        local($str) = @_;
        eval " &waddchstr(defined &stdscr && &stdscr,$str)";
    }';
    eval 'sub addchnstr {
        local($str,$n) = @_;
        eval " &waddchnstr(defined &stdscr && &stdscr,$str, $n)";
    }';
    eval 'sub insdelln {
        local($n) = @_;
        eval " &winsdelln(defined &stdscr && &stdscr, $n)";
    }';
    eval 'sub insstr {
        local($s) = @_;
        eval " &winsstr(defined &stdscr && &stdscr, $s)";
    }';
    eval 'sub insnstr {
        local($s,$n) = @_;
        eval " &winsnstr(defined &stdscr && &stdscr, $s, $n)";
    }';
    eval 'sub mvwaddch {
        local($win,$y,$x,$ch) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddch($win,$ch))";
    }';
    eval 'sub mvwgetch {
        local($win,$y,$x) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wgetch($win))";
    }';
    eval 'sub mvwaddchnstr {
        local($win,$y,$x,$str,$n) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddchnstr($win,$str,$n))";
    }';
    eval 'sub mvwaddchstr {
        local($win,$y,$x,$str) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddchnstr($win,$str,-1))";
    }';
    eval 'sub mvwaddnstr {
        local($win,$y,$x,$str,$n) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddnstr($win,$str,$n))";
    }';
    eval 'sub mvwaddstr {
        local($win,$y,$x,$str) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &waddnstr($win,$str,-1))";
    }';
    eval 'sub mvwgetstr {
        local($win,$y,$x,$str) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wgetstr($win,$str))";
    }';
    eval 'sub mvwinch {
        local($win,$y,$x) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winch($win))";
    }';
    eval 'sub mvwdelch {
        local($win,$y,$x) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &wdelch($win))";
    }';
    eval 'sub mvwinsch {
        local($win,$y,$x,$c) = @_;
        eval "( &wmove($win,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winsch($win,$c))";
    }';
    eval 'sub mvaddch {
        local($y,$x,$ch) = @_;
        eval " &mvwaddch(defined &stdscr && &stdscr,$y,$x,$ch)";
    }';
    eval 'sub mvgetch {
        local($y,$x) = @_;
        eval " &mvwgetch(defined &stdscr && &stdscr,$y,$x)";
    }';
    eval 'sub mvaddnstr {
        local($y,$x,$str,$n) = @_;
        eval " &mvwaddnstr(defined &stdscr && &stdscr,$y,$x,$str,$n)";
    }';
    eval 'sub mvaddstr {
        local($y,$x,$str) = @_;
        eval " &mvwaddstr(defined &stdscr && &stdscr,$y,$x,$str)";
    }';
    eval 'sub mvgetstr {
        local($y,$x,$str) = @_;
        eval " &mvwgetstr(defined &stdscr && &stdscr,$y,$x,$str)";
    }';
    eval 'sub mvinch {
        local($y,$x) = @_;
        eval " &mvwinch(defined &stdscr && &stdscr,$y,$x)";
    }';
    eval 'sub mvdelch {
        local($y,$x) = @_;
        eval " &mvwdelch(defined &stdscr && &stdscr,$y,$x)";
    }';
    eval 'sub mvinsch {
        local($y,$x,$c) = @_;
        eval " &mvwinsch(defined &stdscr && &stdscr,$y,$x,$c)";
    }';
    eval 'sub mvwinsstr {
        local($w, $y, $x, $s) = @_;
        eval "( &wmove($w,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winsstr($w,$s))";
    }';
    eval 'sub mvwinsnstr {
        local($w, $y, $x, $s, $n) = @_;
        eval "( &wmove($w,$y,$x) == defined &ERR && &ERR ? defined &ERR && &ERR :  &winsnstr($w,$s,$n))";
    }';
    eval 'sub mvinsstr {
        local($y,$x,$s) = @_;
        eval " &mvwinsstr(defined &stdscr && &stdscr,$y,$x,$s)";
    }';
    eval 'sub mvinsnstr {
        local($y,$x,$s,$n) = @_;
        eval " &mvwinsnstr(defined &stdscr && &stdscr,$y,$x,$s,$n)";
    }';
    eval 'sub KEY_MIN {0401;}';
    eval 'sub KEY_BREAK {0401;}';
    eval 'sub KEY_DOWN {0402;}';
    eval 'sub KEY_UP {0403;}';
    eval 'sub KEY_LEFT {0404;}';
    eval 'sub KEY_RIGHT {0405;}';
    eval 'sub KEY_HOME {0406;}';
    eval 'sub KEY_BACKSPACE {0407;}';
    eval 'sub KEY_F0 {0410;}';
    eval 'sub KEY_F {
        local($n) = @_;
        eval "(defined &KEY_F0 && &KEY_F0+($n))";
    }';
    eval 'sub KEY_DL {0510;}';
    eval 'sub KEY_IL {0511;}';
    eval 'sub KEY_DC {0512;}';
    eval 'sub KEY_IC {0513;}';
    eval 'sub KEY_EIC {0514;}';
    eval 'sub KEY_CLEAR {0515;}';
    eval 'sub KEY_EOS {0516;}';
    eval 'sub KEY_EOL {0517;}';
    eval 'sub KEY_SF {0520;}';
    eval 'sub KEY_SR {0521;}';
    eval 'sub KEY_NPAGE {0522;}';
    eval 'sub KEY_PPAGE {0523;}';
    eval 'sub KEY_STAB {0524;}';
    eval 'sub KEY_CTAB {0525;}';
    eval 'sub KEY_CATAB {0526;}';
    eval 'sub KEY_ENTER {0527;}';
    eval 'sub KEY_SRESET {0530;}';
    eval 'sub KEY_RESET {0531;}';
    eval 'sub KEY_PRINT {0532;}';
    eval 'sub KEY_LL {0533;}';
    eval 'sub KEY_A1 {0534;}';
    eval 'sub KEY_A3 {0535;}';
    eval 'sub KEY_B2 {0536;}';
    eval 'sub KEY_C1 {0537;}';
    eval 'sub KEY_C3 {0540;}';
    eval 'sub KEY_BTAB {0541;}';
    eval 'sub KEY_BEG {0542;}';
    eval 'sub KEY_CANCEL {0543;}';
    eval 'sub KEY_CLOSE {0544;}';
    eval 'sub KEY_COMMAND {0545;}';
    eval 'sub KEY_COPY {0546;}';
    eval 'sub KEY_CREATE {0547;}';
    eval 'sub KEY_END {0550;}';
    eval 'sub KEY_EXIT {0551;}';
    eval 'sub KEY_FIND {0552;}';
    eval 'sub KEY_HELP {0553;}';
    eval 'sub KEY_MARK {0554;}';
    eval 'sub KEY_MESSAGE {0555;}';
    eval 'sub KEY_MOVE {0556;}';
    eval 'sub KEY_NEXT {0557;}';
    eval 'sub KEY_OPEN {0560;}';
    eval 'sub KEY_OPTIONS {0561;}';
    eval 'sub KEY_PREVIOUS {0562;}';
    eval 'sub KEY_REDO {0563;}';
    eval 'sub KEY_REFERENCE {0564;}';
    eval 'sub KEY_REFRESH {0565;}';
    eval 'sub KEY_REPLACE {0566;}';
    eval 'sub KEY_RESTART {0567;}';
    eval 'sub KEY_RESUME {0570;}';
    eval 'sub KEY_SAVE {0571;}';
    eval 'sub KEY_SBEG {0572;}';
    eval 'sub KEY_SCANCEL {0573;}';
    eval 'sub KEY_SCOMMAND {0574;}';
    eval 'sub KEY_SCOPY {0575;}';
    eval 'sub KEY_SCREATE {0576;}';
    eval 'sub KEY_SDC {0577;}';
    eval 'sub KEY_SDL {0600;}';
    eval 'sub KEY_SELECT {0601;}';
    eval 'sub KEY_SEND {0602;}';
    eval 'sub KEY_SEOL {0603;}';
    eval 'sub KEY_SEXIT {0604;}';
    eval 'sub KEY_SFIND {0605;}';
    eval 'sub KEY_SHELP {0606;}';
    eval 'sub KEY_SHOME {0607;}';
    eval 'sub KEY_SIC {0610;}';
    eval 'sub KEY_SLEFT {0611;}';
    eval 'sub KEY_SMESSAGE {0612;}';
    eval 'sub KEY_SMOVE {0613;}';
    eval 'sub KEY_SNEXT {0614;}';
    eval 'sub KEY_SOPTIONS {0615;}';
    eval 'sub KEY_SPREVIOUS {0616;}';
    eval 'sub KEY_SPRINT {0617;}';
    eval 'sub KEY_SREDO {0620;}';
    eval 'sub KEY_SREPLACE {0621;}';
    eval 'sub KEY_SRIGHT {0622;}';
    eval 'sub KEY_SRSUME {0623;}';
    eval 'sub KEY_SSAVE {0624;}';
    eval 'sub KEY_SSUSPEND {0625;}';
    eval 'sub KEY_SUNDO {0626;}';
    eval 'sub KEY_SUSPEND {0627;}';
    eval 'sub KEY_UNDO {0630;}';
    eval 'sub KEY_MAX {0777;}';
}
1;
